/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CustomerEngagementSection type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CustomerEngagementSection{}

// CustomerEngagementSection struct for CustomerEngagementSection
type CustomerEngagementSection struct {
	BeforeDays *int32 `json:"before_days,omitempty"`
	AfterDays *int32 `json:"after_days,omitempty"`
	ActivityTypes []string `json:"activity_types"`
	LowerThreshold int32 `json:"lower_threshold"`
	UpperThreshold *int32 `json:"upper_threshold,omitempty"`
}

// NewCustomerEngagementSection instantiates a new CustomerEngagementSection object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCustomerEngagementSection(activityTypes []string, lowerThreshold int32) *CustomerEngagementSection {
	this := CustomerEngagementSection{}
	this.ActivityTypes = activityTypes
	this.LowerThreshold = lowerThreshold
	return &this
}

// NewCustomerEngagementSectionWithDefaults instantiates a new CustomerEngagementSection object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCustomerEngagementSectionWithDefaults() *CustomerEngagementSection {
	this := CustomerEngagementSection{}
	return &this
}

// GetBeforeDays returns the BeforeDays field value if set, zero value otherwise.
func (o *CustomerEngagementSection) GetBeforeDays() int32 {
	if o == nil || IsNil(o.BeforeDays) {
		var ret int32
		return ret
	}
	return *o.BeforeDays
}

// GetBeforeDaysOk returns a tuple with the BeforeDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomerEngagementSection) GetBeforeDaysOk() (*int32, bool) {
	if o == nil || IsNil(o.BeforeDays) {
		return nil, false
	}
	return o.BeforeDays, true
}

// HasBeforeDays returns a boolean if a field has been set.
func (o *CustomerEngagementSection) HasBeforeDays() bool {
	if o != nil && !IsNil(o.BeforeDays) {
		return true
	}

	return false
}

// SetBeforeDays gets a reference to the given int32 and assigns it to the BeforeDays field.
func (o *CustomerEngagementSection) SetBeforeDays(v int32) {
	o.BeforeDays = &v
}

// GetAfterDays returns the AfterDays field value if set, zero value otherwise.
func (o *CustomerEngagementSection) GetAfterDays() int32 {
	if o == nil || IsNil(o.AfterDays) {
		var ret int32
		return ret
	}
	return *o.AfterDays
}

// GetAfterDaysOk returns a tuple with the AfterDays field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomerEngagementSection) GetAfterDaysOk() (*int32, bool) {
	if o == nil || IsNil(o.AfterDays) {
		return nil, false
	}
	return o.AfterDays, true
}

// HasAfterDays returns a boolean if a field has been set.
func (o *CustomerEngagementSection) HasAfterDays() bool {
	if o != nil && !IsNil(o.AfterDays) {
		return true
	}

	return false
}

// SetAfterDays gets a reference to the given int32 and assigns it to the AfterDays field.
func (o *CustomerEngagementSection) SetAfterDays(v int32) {
	o.AfterDays = &v
}

// GetActivityTypes returns the ActivityTypes field value
func (o *CustomerEngagementSection) GetActivityTypes() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.ActivityTypes
}

// GetActivityTypesOk returns a tuple with the ActivityTypes field value
// and a boolean to check if the value has been set.
func (o *CustomerEngagementSection) GetActivityTypesOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ActivityTypes, true
}

// SetActivityTypes sets field value
func (o *CustomerEngagementSection) SetActivityTypes(v []string) {
	o.ActivityTypes = v
}

// GetLowerThreshold returns the LowerThreshold field value
func (o *CustomerEngagementSection) GetLowerThreshold() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.LowerThreshold
}

// GetLowerThresholdOk returns a tuple with the LowerThreshold field value
// and a boolean to check if the value has been set.
func (o *CustomerEngagementSection) GetLowerThresholdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LowerThreshold, true
}

// SetLowerThreshold sets field value
func (o *CustomerEngagementSection) SetLowerThreshold(v int32) {
	o.LowerThreshold = v
}

// GetUpperThreshold returns the UpperThreshold field value if set, zero value otherwise.
func (o *CustomerEngagementSection) GetUpperThreshold() int32 {
	if o == nil || IsNil(o.UpperThreshold) {
		var ret int32
		return ret
	}
	return *o.UpperThreshold
}

// GetUpperThresholdOk returns a tuple with the UpperThreshold field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CustomerEngagementSection) GetUpperThresholdOk() (*int32, bool) {
	if o == nil || IsNil(o.UpperThreshold) {
		return nil, false
	}
	return o.UpperThreshold, true
}

// HasUpperThreshold returns a boolean if a field has been set.
func (o *CustomerEngagementSection) HasUpperThreshold() bool {
	if o != nil && !IsNil(o.UpperThreshold) {
		return true
	}

	return false
}

// SetUpperThreshold gets a reference to the given int32 and assigns it to the UpperThreshold field.
func (o *CustomerEngagementSection) SetUpperThreshold(v int32) {
	o.UpperThreshold = &v
}

func (o CustomerEngagementSection) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CustomerEngagementSection) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.BeforeDays) {
		toSerialize["before_days"] = o.BeforeDays
	}
	if !IsNil(o.AfterDays) {
		toSerialize["after_days"] = o.AfterDays
	}
	toSerialize["activity_types"] = o.ActivityTypes
	toSerialize["lower_threshold"] = o.LowerThreshold
	if !IsNil(o.UpperThreshold) {
		toSerialize["upper_threshold"] = o.UpperThreshold
	}
	return toSerialize, nil
}

type NullableCustomerEngagementSection struct {
	value *CustomerEngagementSection
	isSet bool
}

func (v NullableCustomerEngagementSection) Get() *CustomerEngagementSection {
	return v.value
}

func (v *NullableCustomerEngagementSection) Set(val *CustomerEngagementSection) {
	v.value = val
	v.isSet = true
}

func (v NullableCustomerEngagementSection) IsSet() bool {
	return v.isSet
}

func (v *NullableCustomerEngagementSection) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCustomerEngagementSection(val *CustomerEngagementSection) *NullableCustomerEngagementSection {
	return &NullableCustomerEngagementSection{value: val, isSet: true}
}

func (v NullableCustomerEngagementSection) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCustomerEngagementSection) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


